// @ myth - server - stair.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef STAIR_HEADER
#define STAIR_HEADER

// @@ include

#include "server/object.h"
#include "common/command.h"
#include "server/global.h"

// @@ STAIR

class STAIR : public OBJECT
{
private:
    char MyLook;
    level_type LevelUp;
    char WhereUp;
    level_type LevelDown;
    char WhereDown;
public:
    object_type type()
    { return OBJECT_STAIR; }
    char look()
    { return MyLook; }
    comp compare(OBJECT* object);
    const char* name()
    { return "stair"; }
    long size()
    { return 1L; }
    bool MoveUp(LEVEL*, MONSTER* monster);
    bool MoveDown(LEVEL*, MONSTER*);
    void save(BINARY* binary);
    STAIR(BINARY* binary);
    STAIR(PARSE* parse);
    STAIR(char look, level_type up, char u_pos, level_type down, char d_pos);
};

// @@ STAIR_DOWN
 
class STAIR_DOWN : public STAIR
{
public:
    STAIR_DOWN(level_type type) : ('>', LEVEL_ERROR, '>', type, '<') { }
};

// @@ STAIR_UP
 
class STAIR_UP : public STAIR
{
public:
    STAIR_UP(level_type type) : ('<', type, '>', LEVEL_ERROR, '<') { }
};

// @@ end

#endif STAIR_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
